From 62cd258cad2fde90ad0b0fb0ab27dd94614548c2 Mon Sep 17 00:00:00 2001
From: Chao Long <longchao@uniontech.com>
Date: Fri, 25 Sep 2020 10:16:51 +0800
Subject: [PATCH v2] ole32: Check invalid parameters for ReleaseStgMedium().

Signed-off-by: Chao Long <longchao@uniontech.com>
---
 dlls/ole32/ole2.c       | 2 ++
 dlls/ole32/tests/ole2.c | 7 +++++++
 2 files changed, 9 insertions(+)

diff --git a/dlls/ole32/ole2.c b/dlls/ole32/ole2.c
index 15c4f8234f..4464ba0714 100644
--- a/dlls/ole32/ole2.c
+++ b/dlls/ole32/ole2.c
@@ -2023,6 +2023,8 @@ found:
 void WINAPI ReleaseStgMedium(
   STGMEDIUM* pmedium)
 {
+  if (!pmedium) return;
+
   switch (pmedium->tymed)
   {
     case TYMED_HGLOBAL:
diff --git a/dlls/ole32/tests/ole2.c b/dlls/ole32/tests/ole2.c
index cd7eb83923..2a7fcdcc74 100644
--- a/dlls/ole32/tests/ole2.c
+++ b/dlls/ole32/tests/ole2.c
@@ -4610,6 +4610,12 @@ static void test_OleCreateStaticFromData(void)
     IStorage_Release(storage);
 }
 
+static void test_ReleaseStgMedium(void)
+{
+    STGMEDIUM *med = NULL;
+    ReleaseStgMedium(med);
+}
+
 START_TEST(ole2)
 {
     DWORD dwRegister;
@@ -4661,6 +4667,7 @@ START_TEST(ole2)
     test_data_cache_save_data();
     test_data_cache_contents();
     test_OleCreateStaticFromData();
+    test_ReleaseStgMedium();
 
     CoUninitialize();
 }
-- 
2.20.1

